package com.css.simulation.resource.scheduler.mapper;

import com.css.simulation.resource.scheduler.pojo.po.OgtPO;
import org.apache.ibatis.annotations.*;
import org.apache.ibatis.type.JdbcType;

import java.util.List;

@Mapper
public interface SensorOgtMapper {

    @Results(id = "camera", value = {
            @Result(column = "name", property = "sensor_name", jdbcType = JdbcType.VARCHAR),
            @Result(column = "horizontal_field_angle", property = "sensor_fovH", jdbcType = JdbcType.DECIMAL),
            @Result(column = "vertical_field_angle", property = "sensor_fovV", jdbcType = JdbcType.DECIMAL),
            @Result(column = "blind_zone_distance", property = "sensor_near", jdbcType = JdbcType.DECIMAL),
            @Result(column = "detection_distance", property = "sensor_far", jdbcType = JdbcType.DECIMAL),
            @Result(column = "range_display", property = "sensor_display", jdbcType = JdbcType.BOOLEAN),
            @Result(column = "max_objects", property = "sensor_maxObjects", jdbcType = JdbcType.INTEGER),
            @Result(column = "target_filter", property = "sensor_filter", jdbcType = JdbcType.VARCHAR),
            @Result(column = "sensor_x", property = "sensor_x", jdbcType = JdbcType.DECIMAL),
            @Result(column = "sensor_y", property = "sensor_y", jdbcType = JdbcType.DECIMAL),
            @Result(column = "sensor_z", property = "sensor_z", jdbcType = JdbcType.DECIMAL),
            @Result(column = "sensor_h", property = "sensor_h", jdbcType = JdbcType.DECIMAL),
            @Result(column = "sensor_p", property = "sensor_p", jdbcType = JdbcType.DECIMAL),
            @Result(column = "sensor_r", property = "sensor_r", jdbcType = JdbcType.DECIMAL),
            @Result(column = "sensor_port", property = "sensor_port", jdbcType = JdbcType.INTEGER),
    })
    @Select("select mso.name,\n" +
            "       mso.horizontal_field_angle_left,\n" +
            "       mso.horizontal_field_angle_right,\n" +
            "       mso.vertical_field_angle_top,\n" +
            "       mso.vertical_field_angle_bottom,\n" +
            "       mso.blind_zone_distance,\n" +
            "       mso.detection_distance,\n" +
            "       mso.range_display,\n" +
            "       mso.max_objects,\n" +
            "       mso.target_filter,\n" +
            "       rvs.sensor_x,\n" +
            "       rvs.sensor_y,\n" +
            "       rvs.sensor_z,\n" +
            "       rvs.sensor_h,\n" +
            "       rvs.sensor_p,\n" +
            "       rvs.sensor_r,\n" +
            "       rvs.sensor_port\n" +
            "from model_sensor_ogt mso left join relation_vehicle_sensor rvs on mso.id = rvs.sensor_id\n" +
            "where rvs.vehicle_id = #{vehicleId}")
    List<OgtPO> selectOgtByVehicleId(@Param("vehicleId") String vehicleId);
}
